=== debian/changelog ===
volk (3.1.2-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:26:19 +1100

volk (3.1.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063052

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 23:20:12 +0000

volk (3.1.2-1) unstable; urgency=medium

  * New upstream release.
    - Replace sse2neon with native NEON
    - Remove loop unrolling
    - Simplify Spiral-generated code

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 25 Feb 2024 08:51:33 -0500
