=== debian/rules ===
#!/usr/bin/make -f
#export DEB_BUILD_MAINT_OPTIONS += hardening=+all
#export DH_VERBOSE=1

%:
	dh $@ --with python3

override_dh_auto_build-indep:
	cmake --build obj-* --target all
	cmake --build obj-* --target volk_doc
#	cmake --build obj-* --target volk_pdf_doc

override_dh_auto_install:
	dh_auto_install
	find debian -type d -empty -delete

override_dh_auto_clean:
	dh_auto_clean
	rm -rf gen/__pycache__
