=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -93,19 +93,35 @@
     OUTPUT_VARIABLE arch_flag_lines
     OUTPUT_STRIP_TRAILING_WHITESPACE)
 
+try_compile(
+    HAVE_RVV_INTRINSICS
+    ${CMAKE_BINARY_DIR}
+    ${CMAKE_SOURCE_DIR}/cmake/Checks/check-rvv-intrinsics.c
+)
+if(HAVE_RVV_INTRINSICS)
+    message(STATUS "Checking RVV intrinsics - found")
+else()
+    message(STATUS "Checking RVV intrinsics - not found")
+endif()
+
 macro(check_arch arch_name)
     set(flags ${ARGN})
     set(have_${arch_name} TRUE)
+
+    string(SUBSTRING "${arch_name}" 0 2 arch_prefix)
     foreach(flag ${flags})
         if(MSVC AND (${flag} STREQUAL "/arch:SSE2" OR ${flag} STREQUAL "/arch:SSE"))
             # SSE/SSE2 is supported in MSVC since VS 2005 but flag not available when compiling 64-bit so do not check
+        elseif("${arch_prefix}" STREQUAL "rv" AND NOT HAVE_RVV_INTRINSICS)
+            message(STATUS "Skipping ${arch_name} due to missing RVV intrinsics support")
+            set(have_${arch_name} FALSE)
         else()
             include(CheckCXXCompilerFlag)
             set(have_flag have${flag})
             #make the have_flag have nice alphanum chars (just for looks/not necessary)
             execute_process(
                 COMMAND ${PYTHON_EXECUTABLE} -c
-                        "import re; print(re.sub('\\W', '_', '${have_flag}'))"
+                        "import re; print(re.sub(r'\\W', '_', '${have_flag}'))"
                 OUTPUT_VARIABLE have_flag
                 OUTPUT_STRIP_TRAILING_WHITESPACE)
             if(VOLK_FLAG_CHECK_FLAGS)
@@ -255,17 +271,16 @@
 ########################################################################
 if(NOT CROSSCOMPILE_MULTILIB AND CPU_IS_x86)
     include(CheckTypeSize)
-    check_type_size("void*[8]" SIZEOF_CPU BUILTIN_TYPES_ONLY)
-    if(${SIZEOF_CPU} EQUAL 64)
+    cmake_host_system_information(RESULT ASSUME_64BIT_HOST QUERY IS_64BIT)
+    if(ASSUME_64BIT_HOST)
         overrule_arch(32 "CPU width is 64 bits")
-    endif()
-    if(${SIZEOF_CPU} EQUAL 32)
+    else()
         overrule_arch(64 "CPU width is 32 bits")
     endif()
 
     #MSVC 64 bit does not have MMX, overrule it
     if(MSVC)
-        if(${SIZEOF_CPU} EQUAL 64)
+        if(ASSUME_64BIT_HOST)
             overrule_arch(mmx "No MMX for Win64")
         endif()
         force_arch(sse "Built-in for MSVC > 2013")
@@ -295,15 +310,3 @@
 ########################################################################
 # determine available machines given the available architectures
 ########################################################################
-execute_process(
-    COMMAND
-        ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
-        ${PROJECT_SOURCE_DIR}/gen/volk_compile_utils.py --mode "machines" --archs
-        "${available_archs}"
-    OUTPUT_VARIABLE available_machines
-    OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-########################################################################
-# Implement machine overruling for redundant machines:
-# A machine is redundant when expansion rules occur,
-# and the arch superset passes configuration checks.
