=== debian/changelog ===
volk (3.2.0-3) unstable; urgency=medium

  * update to v3.2.0-15-gf9d2ed6
    (except cx-limited-range-Scope-compile-feature)
  * Standards-Version 4.7.2 no changes
  * pass on known test failures (Closes: #1098070)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 19 Sep 2025 19:15:06 -0400

volk (3.2.0-2) unstable; urgency=medium

  * upload to unstable
  * Standards-Version 4.7.1 no changes

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 24 Feb 2025 20:17:13 -0500

volk (3.2.0-1) experimental; urgency=medium

  * New upstream release.
  - New and improved kernels
     - add RISC-V Vector extension (RVV) kernels
     - New AVX512F implementation
  - Improved builds
     - cmake: Fix 64bit host CPU detection
     - cmake: Suppress invalid escape sequence warnings with Python 3.12
     - cmake/pkgconfig: use CMAKE_INSTALL_FULL_* variables
     - cmake: Fix VOLK as a submodule build issue
     - Adds toolchain file for Raspberry Pi 5
  - New and improved tests
     - gtest: Start work on new test infrastructure
     - tests: Add a log info print test
     - gtest: Make gtest an install dependency
     - gtest: Enable GTests in CI workflows
     - tests: Beautify test output
  - Documentation
     - cpu_features: Update hints in README
  - Code quality
     - Add const to several args
  - Usability features
     - feature: add env variable kernel override
  * update Standards-Version (no changes)
  * upload to experimental for library soversion change.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 03 Feb 2025 22:07:56 -0500
