=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: volk
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: A. Maitland Bottoms <bottoms@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+Maintainer: A. Maitland Bottoms <bottoms@debian.org>
+Build-Depends: cmake,
                debhelper-compat (= 13),
                dh-python,
                libcpu-features-dev [amd64 arm64 armel armhf i386 mips64el ppc64 ppc64el riscv64 s390x powerpc x32],
@@ -11,16 +10,13 @@
                python3-dev,
                python3-mako
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://libvolk.org
 Vcs-Browser: https://salsa.debian.org/bottoms/pkg-volk
 Vcs-Git: https://salsa.debian.org/bottoms/pkg-volk.git
 
-Package: libvolk3.1t64
-Provides: ${t64:Provides}
-Replaces: libvolk3.1
-Breaks: libvolk3.1 (<< ${source:Version})
+Package: libvolk3.2
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,7 +33,7 @@
 Package: libvolk-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk3.1t64 (=${binary:Version}), ${misc:Depends}
+Depends: libvolk3.2 (=${binary:Version}), ${misc:Depends}
 Breaks: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
 Replaces: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
 Suggests: libvolk-doc
@@ -55,8 +51,7 @@
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk3.1t64 (=${binary:Version}),
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
 Breaks: libvolk1-bin, libvolk1.0-bin, libvolk2-bin
